package com.db.service.main;

import com.alibaba.fastjson.JSON;
import com.db.service.dao.IHelloDao;
import com.db.service.dao.ITestDao;
import com.db.service.dao.ITestDao2;
import com.db.service.mapper.TestRowMapper;
import com.db.service.model.TTest;
import com.db.service.model.TTest2;
import com.db.service.model.TTestExample;
import com.elab.core.bean.PageModel;
import com.elab.core.dao.BasicBaseDao;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.*;

/**
 * 基于拓展的测试用例
 *
 * @author Liukx
 * @create 2018-04-20 15:57
 * @email liukx@elab-plus.com
 **/
@RunWith(SpringJUnit4ClassRunner.class)  //使用junit4进行测试
@ContextConfiguration
        ({"classpath:applicationContext-*.xml",})
public class BasicBaseDaoCase {

    @Autowired
    private BasicBaseDao basicBaseDao;

    @Autowired
    private ITestDao testDao;

    @Autowired
    private ITestDao2 testDao2;

    @Autowired
    private IHelloDao helloDao;

//    @Test
//    public void executeQueryforListMap() {
//        Map<String, String> map = new HashMap<>();
//        map.put("status", "1");
//        List<Map<String, Object>> maps = basicBaseDao.executeQueryForListMap("com.db.service.dao.ITestDao.selectByExample", map);
//        System.out.println(maps.size());
//    }
//
//    @Test
//    public void executeQueryList() {
//        TTest test = new TTest();
//        test.setStatus("1");
//        List<TTest> tTests = basicBaseDao.executeQueryList("com.db.service.dao.ITestDao.selectByExample", test, TTest.class);
//        System.out.println(tTests.size());
//    }
//
//    @Test
//    public void executeQueryBigDataList() {
//        TTest test = new TTest();
//        test.setStatus("1");
//        List<TTest> tTests = basicBaseDao.executeQueryBigDataList("com.db.service.dao.ITestDao.selectByExample", test, TTest.class);
//        System.out.println(tTests.size());
//    }
//
//
//    @Test
//    public void executeInsert() {
//        TTest test = new TTest();
//        test.setStatus("1");
//        test.setUsername("某某某xx");
//        int i = basicBaseDao.insert("test.insert", test);
//        System.out.println(i);
//    }
//
//    @Test
//    public void executeUpdate() {
//        TTest test = new TTest();
//        test.setId(1);
//        test.setStatus("1");
//        test.setUsername("某某某xx");
//        int i = basicBaseDao.executeUpdate("test.updateByPrimaryKey", test);
//        System.out.println(i);
//    }

    ////////////////////////////代理测试/////////////////////////////////////////

    @Test
    public void testInsertCase() throws Exception {
        TTest test = new TTest();
        test.setStatus("1");
        test.setUsername("某某某xx111");
//        test.setTestId("123123");
        test.setSex("Man");
        int insert = testDao.insert(test);
        System.out.println(insert);
    }

    @Test
    public void testUpdateCase() throws Exception {
        TTest test = new TTest();
        test.setId(1);
        test.setStatus("1");
        test.setUsername("某某某xx33333333");
        int insert = testDao.updateById(test);
        System.out.println(insert);
    }

    @Test
    public void testQueryCase() throws Exception {
        TTest test = new TTest();
//        test.setId(1123);
        test.setStatus("1");
//        test.setTestId("21");
//        test.setUsername("某某某xx2121212");
        List<TTest> tTests = testDao.selectByList(test);
//        test.setId(1);
//        TTest test1 = testDao.selectByObject(test);
//        System.out.println(test1.toString());
//        System.out.println(tTests.size());
    }

    @Test
    public void testExampleQueryCase() throws Exception {
        TTest test = new TTest();
//        test.setId(1);
        test.setStatus("1");
//        test.setUsername("某某某xx2121212");
        TTestExample example = new TTestExample();
        TTestExample.Criteria criteria = example.createCriteria();
//        criteria.andIdEqualTo(1);
        List<Integer> list = new ArrayList<>();
        list.add(1);
        list.add(3);
        list.add(4);
        criteria.andIdIn(list);

//        criteria.andUsernameLike("某某某xx333%");

        List<TTest> tTests = testDao2.find(example);
        System.out.println(tTests);
    }

    @Test
    public void testProxyDao() {
        TTest test = new TTest();
        test.setStatus("1");
        List<TTest2> testList = testDao.getTestList(test);
        System.out.println();

//        LinkedHashMap<String, Object> map = new LinkedHashMap();
//        map.put("id", "1");
//        List<CustomerDTO> customerDTOs = helloDao.getListForObject(map);
//        System.out.println(testList.size() + "\t" + customerDTOs.size());
    }

    @Test
    public void testPageDao() throws Exception {
        TTest test = new TTest();
        test.setStatus("1");

        PageModel pageModel = new PageModel(0, 3, 10);
        pageModel.setOrderby("order by id desc");
        PageModel<TTest> tTestPageModel = testDao.selectByPage(pageModel, test);
        System.out.println(JSON.toJSONString(tTestPageModel));
    }

    @Test
    public void testSelectByIdDao() throws Exception {
        TTest test = testDao.selectById("1");
        System.out.println(test.toString());
    }

    @Test
    public void testSelectByMapper() throws Exception {
        TTest test = new TTest();
        test.setStatus("1");
        TestRowMapper mapper = new TestRowMapper();
        List<TTest> tTests1 = testDao.selectByList(test);
        List<TTest> tTests = testDao.selectByMapper(test, mapper);
        System.out.println(tTests.toString());
    }

    @Test
    public void testSelectByMapper2() throws Exception {
        Map<String, Object> map = new HashMap<>();
        map.put("status", "1");
        TestRowMapper mapper = new TestRowMapper();
        List<TTest> tTests = testDao.getTestList(map, mapper);
        System.out.println(tTests.toString());
    }

    ///////////////////////////////////// service //////////////////////////////////
    @Test
    public void testService() {

    }

    @Test
    public void testBatchBeanInsert() {
        List<TTest> list = new ArrayList<>();
        for (int i = 0; i < 100; i++) {
            TTest test = new TTest();
            test.setStatus("1");
            test.setUsername("batchTest_" + i);
            test.setSex("Man");
            test.setTestId("bbbb");
            list.add(test);
        }

        int[] ints = testDao.batchInsert(list);
        System.out.println(Arrays.toString(ints));
    }

    @Test
    public void testBatchMapInsert() {
        List<Map> maps = new ArrayList<>();

        for (int i = 0; i < 10; i++) {
            Map<String, String> map = new HashMap<>();
            map.put("status", "1");
            map.put("username", "batchMap_" + i);
            map.put("sex", "Man");
            maps.add(map);
        }
        int[] ints = testDao.batchInsert(maps);
        System.out.println(ints.length);
    }

//    public static void main(String[] args) {
//        BasicBaseDaoCase basicBaseDaoCase = new BasicBaseDaoCase();
//        basicBaseDaoCase.executeQueryforListMap();
//        basicBaseDaoCase.executeQueryList();
//        basicBaseDaoCase.executeQueryBigDataList();
//        basicBaseDaoCase.executeInsert();
//        basicBaseDaoCase.executeUpdate();
//    }


}
