package com.elab.mq.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * @author liuhx
 * @create 2019/05/16 19:32
 * @email liuhx@elab-plus.com
 **/
@Table(name = "mq_producer", catalog = "elab_db")
@ApiModel(description = "消息队列生产者 实体")
public class ProducerEntity {

    @Id
    @ApiModelProperty(name = "id", value = "主键")
    private Integer id;

    @Column(name = "module_name")
    @ApiModelProperty(name = "moduleName", value = "微服务模块名")
    private String moduleName;

    @Column(name = "house_id")
    @ApiModelProperty(name = "houseId", value = "项目id")
    private Integer houseId;

    @Column(name = "producer_status")
    @ApiModelProperty(name = "producerStatus", value = "生产者状态 1成功-1失败")
    private Integer producerStatus;

    @Column(name = "group_id")
    @ApiModelProperty(name = "groupId", value = "队列的groupId")
    private String groupId;

    @Column(name = "topic_id")
    @ApiModelProperty(name = "topicId", value = "队列通道id")
    private String topicId;

    @Column(name = "content")
    @ApiModelProperty(name = "content", value = "内容")
    private String content;


    /**
     * 状态：1  有效  -1  无效
     *
     */
    @Column(name = "status")
    @ApiModelProperty(name = "status", value = "状态：1  有效  -1  无效")
    private Integer status;

    /**
     * 创建时间
     *
     */
    @Column(name = "created")
    @ApiModelProperty(name = "created", value = "创建时间")
    private Date created;

    /**
     * 修改时间
     *
     */
    @Column(name = "updated")
    @ApiModelProperty(name = "updated", value = "修改时间")
    private Date updated;

    /**
     * 创建者
     *
     */
    @Column(name = "creator")
    @ApiModelProperty(name = "creator", value = "创建者")
    private String creator;

    /**
     * 修改者
     *
     */
    @Column(name = "updator")
    @ApiModelProperty(name = "updator", value = "修改者")
    private String updator;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getModuleName() {
        return moduleName;
    }

    public void setModuleName(String moduleName) {
        this.moduleName = moduleName;
    }

    public Integer getHouseId() {
        return houseId;
    }

    public void setHouseId(Integer houseId) {
        this.houseId = houseId;
    }

    public Integer getProducerStatus() {
        return producerStatus;
    }

    public void setProducerStatus(Integer producerStatus) {
        this.producerStatus = producerStatus;
    }

    public String getGroupId() {
        return groupId;
    }

    public void setGroupId(String groupId) {
        this.groupId = groupId;
    }

    public String getTopicId() {
        return topicId;
    }

    public void setTopicId(String topicId) {
        this.topicId = topicId;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Date getCreated() {
        return created;
    }

    public void setCreated(Date created) {
        this.created = created;
    }

    public Date getUpdated() {
        return updated;
    }

    public void setUpdated(Date updated) {
        this.updated = updated;
    }

    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getUpdator() {
        return updator;
    }

    public void setUpdator(String updator) {
        this.updator = updator;
    }
}
