package com.elab.spring.utils;

import com.elab.core.utils.GzipUtils;
import org.junit.Assert;
import org.junit.Test;
import org.springframework.web.client.RestTemplate;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.zip.GZIPInputStream;

public class RestTemplateUtilsTest {

    private RestTemplateUtils restTemplateUtils = new RestTemplateUtils();

    private RestTemplate restTemplate = new RestTemplate();

    @Test
    public void post() {
        String url = "http://106.14.133.2:5555/elab-marketing-authentication//ipAddr/getIpAddr";
        String post = restTemplateUtils.post(url, null, String.class);
        System.out.println("--->" + post);
        Assert.assertNotNull(post);
    }

    @Test
    public void get() {
        String url = "http://www.baidu.com";
        String get = restTemplateUtils.get(url, String.class);
        System.out.println("--->" + get);
        Assert.assertNotNull(get);
    }
    public static String conventFromGzip(String str) throws IOException {
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        ByteArrayInputStream in;
        GZIPInputStream gunzip = null;

        in = new ByteArrayInputStream(str.getBytes("ISO-8859-1"));
        gunzip = new GZIPInputStream(in);
        byte[] buffer = new byte[256];
        int n;
        while ((n = gunzip.read(buffer)) >= 0) {
            out.write(buffer, 0, n);
        }
        return out.toString();
    }
    @Test
    public void getInputstream() throws IOException {
        String url = "http://wthrcdn.etouch.cn/weather_mini?city=上海";
        byte[] bytes = restTemplateUtils.get(url, byte[].class);
        String s1 = GzipUtils.unZip(bytes);
        System.out.println(s1);

    }
}